//*****************************************************************************************************
//  1. t@C
//		GraphFrm.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot̃t[EBhENX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//		
//*****************************************************************************************************

#include "stdafx.h"
#include "MmeRecv.h"
#include "GraphFrm.h"
#include <math.h>

#define WM_READY_GRAPH	(WM_APP + 0)

#define SCROLL_MAX	2000

// CGraphFrm

IMPLEMENT_DYNCREATE(CGraphFrm, CFrameWnd)

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::CGraphFrm
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CGraphFrm::CGraphFrm()
{
	m_hThread = NULL;
	m_bExit = FALSE;
	m_fTimeZoom = 1;
	m_fLevelZoom = 1;
	m_fTimeOffset = 0;
	m_fLevelOffset = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::~CGraphFrm
//----------------------------------------------------------------------------------------------------
//  2. @\
//		fXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CGraphFrm::~CGraphFrm()
{
	// [JXbhXbh̏I҂
	if (m_hThread != NULL) {
		m_bExit = TRUE;
		m_oEvent.SetEvent();
		::WaitForSingleObject(m_hThread, 1000);
	}
}


BEGIN_MESSAGE_MAP(CGraphFrm, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(IDM_CLOSE, &CGraphFrm::OnClose)
	ON_MESSAGE(WM_READY_GRAPH, &CGraphFrm::OnReadyGraph)
END_MESSAGE_MAP()


// CGraphFrm bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::PreCreateWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhE쐬O
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CREATESTRUCT		&cs			[I] EBhE쐬\
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CGraphFrm::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::OnCreate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhE쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCREATESTRUCT		lpCreateStruct			[I] EBhE쐬\̂ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		0F@-1FG[
//*****************************************************************************************************
int CGraphFrm::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	static const UINT indicators[] = {
		IDS_STATUS_BAR,
	};

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// r[EBhE쐬
	if (!m_wndGraphView.CreateEx(WS_EX_CLIENTEDGE, NULL, NULL, WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL, CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL)) {
		TRACE0("r[ EBhE쐬ł܂łB\n");
		return -1;
	}

	// XN[o[ݒ
	SCROLLINFO si;
	memset(&si, 0, sizeof(si));
	si.cbSize = sizeof(si);
	si.fMask = SIF_PAGE | SIF_RANGE;
	si.nPage = SCROLL_MAX;
	si.nMax = SCROLL_MAX;
	m_wndGraphView.SetScrollInfo(SB_HORZ, &si, FALSE);
	m_wndGraphView.SetScrollInfo(SB_VERT, &si, FALSE);

	// Xe[^Xo[쐬
	if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators, sizeof(indicators) / sizeof(UINT))) {
		TRACE0("Xe[^X o[̍쐬Ɏs܂B\n");
		return -1;
	}
	m_wndStatusBar.SetPaneStyle(0, SBPS_NOBORDERS | SBPS_STRETCH);

	// _CAOo[쐬
	if (!m_wndGraphBar.Create(this, IDD_GRAPH_BAR, CBRS_BOTTOM, (UINT)-1)) {
		TRACE0("_CAO o[̍쐬Ɏs܂B\n");
		return -1;
	}

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::OnClose
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Close{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::OnClose()
{
	DestroyWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::DispGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Mt@C̃Ot\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pReceiveFilePath	[I] Mt@C(.s)t@CpX
//		SGraphLine	&oGraphLine			[I] Otf[^C\
//		LPCTSTR		pTitle				[I] EBhE^Cg
//		CWnd		*pParentWnd			[I] eEBhE|C^
//		double		fTempRange1			[I] x͈͉
//		double		fTempRange2			[I] x͈͏
//		double		fHeaterRange1		[I] q[^d
//		double		fHeaterRange2		[I] q[^d
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::DispGraph(LPCTSTR pReceiveFilePath, SGraphLine &oGraphLine, LPCTSTR pTitle, CWnd *pParentWnd, double fTempRange1, double fTempRange2, double fHeaterRange1, double fHeaterRange2)
{
	m_sReceiveFilePath = pReceiveFilePath;
	m_oGraphLine = oGraphLine;
	m_fTempRange1 = fTempRange1;
	m_fTempRange2 = fTempRange2;
	m_fHeaterRange1 = fHeaterRange1;
	m_fHeaterRange2 = fHeaterRange2;

	// t[\[X烍[hč쐬
	LoadFrame(IDR_GRAPHFRAME, WS_OVERLAPPEDWINDOW, pParentWnd, NULL);
	SetIcon(AfxGetApp()->LoadIcon(IDR_GRAPHFRAME), FALSE);

	// EBhE^Cgݒ
	SetWindowText(pTitle);

	// Xe[^Xo[Ƀt@CǂݍݒZbg
	m_wndStatusBar.SetPaneText(0, "Reading File");

	// \ƍXV
	ShowWindow(SW_SHOW);

	// t@Cǂݍ݃XbhJniMɉeyڂȂ悤ɕʃXbhōsj
	m_hThread = AfxBeginThread(ReadFileThreadEntry, this, THREAD_PRIORITY_LOWEST)->m_hThread;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ReadFileThreadEntry
//----------------------------------------------------------------------------------------------------
//  2. @\
//		M(.s)t@Cǂݍ݃XbhGg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPVOID		pParam		[I] Xbhp[^(this|C^j
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		UINT		0
//*****************************************************************************************************
UINT CGraphFrm::ReadFileThreadEntry(LPVOID pParam)
{
	((CGraphFrm *)pParam)->ReadFileThread();
	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ReadFileThread
//----------------------------------------------------------------------------------------------------
//  2. @\
//		M(.s)t@Cǂݍ݃Xbh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ReadFileThread()
{
	// t@Cǂݍݏ
	ReadFile(m_sReceiveFilePath);

	// CXbhɓǂݍ݊ʒm
	if (!m_bExit)
		PostMessage(WM_READY_GRAPH);

	m_hThread = NULL;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ReadFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		M(.s)t@Cǂݍݏ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pReceiveNamePath		[I] Mt@CpX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ReadFile(LPCTSTR pReceiveNamePath)
{
	CFile oFile;
	struct {
		char aTime[8];
		BYTE aUserHeader[USER_HEADER_SIZE];
	} oHeaderBuf;
	BYTE aAnalogDataBuf[ANALOG_DATA_SIZE];
	SUserHeader oUserHeader;
	SAnalogData oAnalogData;
	SMmeStatusData oMmeStatusData;
	int nHour, nMinute, nSecond;

	// ǂݍ݃t@CI[v
	if (!oFile.Open(pReceiveNamePath, CFile::modeRead | CFile::shareDenyWrite))
		return;

	// t@Cf[^ǂݏo
	while (!m_bExit) {
		// wb_ǂݍ
		if (oFile.Read(&oHeaderBuf, sizeof(oHeaderBuf)) != sizeof(oHeaderBuf))
			break;

		// f[^MtH[}bg`FbN
		if (sscanf_s(oHeaderBuf.aTime, "%2d:%2d:%2d", &nHour, &nMinute, &nSecond) != 3)
			return;

		// [Uwb_o
		g_oMmeData.GetUserHeader(oHeaderBuf.aUserHeader, oUserHeader);
		switch (oUserHeader.nPacketType) {
		case PACKET_TELEMETRY:
			// ZOgJEg0Ȃ΃AiOf[^ǂݍ
			if (oUserHeader.nSegmentCount == 0) {
				if (oFile.Read(aAnalogDataBuf, sizeof(aAnalogDataBuf)) != sizeof(aAnalogDataBuf))
					return;

				g_oMmeData.GetAnalogData(aAnalogDataBuf, oUserHeader.oTelemetry.oStatusWord, oAnalogData);
				m_oGraphData.AddGraphData(oUserHeader.oTimestamp, oUserHeader.oTelemetry.oStatusWord, oAnalogData);
			}

			// fW^f[^͓ǂݔ΂
			oFile.Seek(oUserHeader.oTelemetry.nDataNum * DIGITAL_DATA_SIZE, CFile::current);
			break;
		case PACKET_MME_STATUS:
			// MMEXe[^Xf[^̃AiOf[^܂ł̃f[^ǂݔ΂
			oFile.Seek(40, CFile::current);

			// AiOf[^ǂݍ
			if (oFile.Read(aAnalogDataBuf, sizeof(aAnalogDataBuf)) != sizeof(aAnalogDataBuf))
				return;

			// Otɒǉ
			g_oMmeData.GetAnalogData(aAnalogDataBuf, oUserHeader.oMmeStatus.oStatusWord, oAnalogData);
			m_oGraphData.AddGraphData(oUserHeader.oTimestamp, oUserHeader.oMmeStatus.oStatusWord, oAnalogData);

			// OHALTG[ǂݔ΂
			oFile.Seek(24, CFile::current);
			break;
		case PACKET_ERROR_STATUS:
			// G[Xe[^X̃f[^ǂݔ΂
			oFile.Seek(oUserHeader.oErrorStatus.nDataNum, CFile::current);
			break;
		case PACKET_MESSAGE:
			// bZ[W̃f[^ǂݔ΂
			oFile.Seek(oUserHeader.oMessage.nDataNum, CFile::current);
			break;
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::DispGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		M̃Ot\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CGraphData	&oGraphData			[I] Otf[^
//		SGraphLine	&oGraphLine			[I] Otf[^C\
//		LPCTSTR		pTitle				[I] EBhE^Cg
//		CWnd		*pParentWnd			[I] eEBhE|C^
//		double		fTempRange1			[I] x͈͉
//		double		fTempRange2			[I] x͈͏
//		double		fHeaterRange1		[I] q[^d
//		double		fHeaterRange2		[I] q[^d
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::DispGraph(CGraphData &oGraphData, SGraphLine &oGraphLine, LPCTSTR pTitle, CWnd *pParentWnd, double fTempRange1, double fTempRange2, double fHeaterRange1, double fHeaterRange2)
{
	m_pGraphData = &oGraphData;
	m_oGraphLine = oGraphLine;
	m_fTempRange1 = fTempRange1;
	m_fTempRange2 = fTempRange2;
	m_fHeaterRange1 = fHeaterRange1;
	m_fHeaterRange2 = fHeaterRange2;

	// t[\[X烍[hč쐬
	LoadFrame(IDR_GRAPHFRAME, WS_OVERLAPPEDWINDOW, pParentWnd, NULL);

	// EBhE^Cgݒ
	SetWindowText(pTitle);

	// \ƍXV
	ShowWindow(SW_SHOW);

	// Otf[^Rs[XbhJniMɉeyڂȂ悤ɕʃXbhōsj
	m_hThread = AfxBeginThread(CopyGraphDataThreadEntry, this, THREAD_PRIORITY_LOWEST)->m_hThread;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::CopyGraphDataThreadEntry
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Otf[^Rs[XbhGg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPVOID		pParam		[I] Xbhp[^(this|C^j
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		UINT		0
//*****************************************************************************************************
UINT CGraphFrm::CopyGraphDataThreadEntry(LPVOID pParam)
{
	((CGraphFrm *)pParam)->CopyGraphDataThread();
	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::CopyGraphDataThread
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Otf[^Rs[Xbh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::CopyGraphDataThread()
{
	// Otf[^Rs[
	m_oGraphData = *m_pGraphData;

	// Rs[ICXbhɒʒm
	if (!m_bExit)
		PostMessage(WM_READY_GRAPH);

	m_hThread = NULL;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::OnReadyGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM		wParam			[I] bZ[Wp[^
//		LPARAM		lParam			[I] bZ[Wp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		0
//*****************************************************************************************************
LRESULT CGraphFrm::OnReadyGraph(WPARAM wParam, LPARAM lParam)
{
	// Time Range擾iŏITimestamp30ȏÕf[^͖j
	int nDataNum = m_oGraphData.GetDataNum();
	if (nDataNum != 0) {
		m_fTimeRange2 = (double)m_oGraphData.GetGraphData(nDataNum - 1).oTimestamp.GetTime();

		for (int i = 0; i < nDataNum; i++) {
			m_fTimeRange1 = (double)m_oGraphData.GetGraphData(i).oTimestamp.GetTime();
			if (m_fTimeRange2 - m_fTimeRange1 < 30 * 24 * 60 * 60)
				break;
		}
	}

	// Data Line\
	m_wndGraphBar.DispDataLine(m_oGraphLine);

	// OtXV
	UpdateGraph();

	// Xe[^Xo[ɏ\
	m_wndStatusBar.SetPaneText(0, "Ready");

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::UpdateGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot\XV
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::UpdateGraph()
{
	double fTimeSpan = m_fTimeRange2 - m_fTimeRange1;

	// ͈͂̕␳
	if (m_fTimeOffset < 0)
		m_fTimeOffset = 0;
	else if (m_fTimeRange1 + fTimeSpan * m_fTimeOffset + 1 / m_fTimeZoom * fTimeSpan > m_fTimeRange2)
		m_fTimeOffset = 1 - 1 / m_fTimeZoom;

	double fTimeRange1 = m_fTimeRange1 + fTimeSpan * m_fTimeOffset;
	double fTimeRange2 = fTimeRange1 + fTimeSpan / m_fTimeZoom;

	double fTempSpan = m_fTempRange2 - m_fTempRange1;

	// c͈͂̕␳
	if (m_fLevelOffset < 0)
		m_fLevelOffset = 0;
	else if (m_fTempRange1 + fTempSpan * m_fLevelOffset + 1 / m_fLevelZoom * fTempSpan > m_fTempRange2)
		m_fLevelOffset = 1 - 1 / m_fLevelZoom;

	double fTempRange1 = m_fTempRange1 + fTempSpan * m_fLevelOffset;
	double fTempRange2 = fTempRange1 + fTempSpan / m_fLevelZoom;

	double fHeaterSpan = m_fHeaterRange2 - m_fHeaterRange1;
	double fHeaterRange1 = m_fHeaterRange1 + fHeaterSpan * m_fLevelOffset;
	double fHeaterRange2 = fHeaterRange1 + fHeaterSpan / m_fLevelZoom;

	// XN[o[̐ݒ
	SCROLLINFO si;
	memset(&si, 0, sizeof(si));
	si.cbSize = sizeof(si);
	si.fMask = SIF_PAGE | SIF_POS;
	si.nPage = (int)(SCROLL_MAX / m_fTimeZoom);
	si.nPos = (int)(m_fTimeOffset * SCROLL_MAX);
	m_wndGraphView.SetScrollInfo(SB_HORZ, &si);

	// cXN[o[̐ݒ
	si.nPage = (int)(SCROLL_MAX / m_fLevelZoom);
	si.nPos = SCROLL_MAX - si.nPage - (int)(m_fLevelOffset * SCROLL_MAX);
	m_wndGraphView.SetScrollInfo(SB_VERT, &si);

	// ͈͂̕\
	m_wndGraphBar.DispHorizontalAxis(fTimeRange1, fTimeRange2);

	// c͈͂̕\
	m_wndGraphBar.DispVerticalAxis(fTempRange1, fTempRange2, fHeaterRange1, fHeaterRange2);

	// Ot\
	m_wndGraphView.DispGraph(
			m_oGraphData,
			m_oGraphLine,
			fTimeRange1, fTimeRange2,
			fTempRange1, fTempRange2,
			fHeaterRange1, fHeaterRange2);

	m_wndGraphView.UpdateWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ChangeGraphLine
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Otf[^CύX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		SGraphLine		&oGraphLine			[I] Otf[^C
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ChangeGraphLine(const SGraphLine &oGraphLine)
{
	m_oGraphLine = oGraphLine;

	UpdateGraph();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ScrollTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fScrollPos			[I] XN[ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ScrollTime(double fScrollPos)
{
	m_fTimeOffset = fScrollPos;

	UpdateGraph();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ZoomTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Y[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fZoomPos			[I] Y[ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ZoomTime(double fZoomPos)
{
	m_fTimeZoom = exp(fZoomPos * 5);

	UpdateGraph();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ScrollLevel
//----------------------------------------------------------------------------------------------------
//  2. @\
//		cXN[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fScrollPos			[I] XN[ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ScrollLevel(double fScrollPos)
{
	m_fLevelOffset = fScrollPos;

	UpdateGraph();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ZoomLevel
//----------------------------------------------------------------------------------------------------
//  2. @\
//		cY[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fZoomPos			[I] Y[ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ZoomLevel(double fZoomPos)
{
	double fCenter = m_fLevelOffset + 0.5 / m_fLevelZoom;
	m_fLevelZoom = exp(fZoomPos * 5);
	m_fLevelOffset = fCenter - 0.5 / m_fLevelZoom;

	UpdateGraph();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::MouseScroll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXɂXN[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fTimeScroll			[I] XN[ʒu
//		double		fLevelScroll		[I] cXN[ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::MouseScroll(double fTimeScroll, double fLevelScroll)
{
	m_fTimeOffset += fTimeScroll / m_fTimeZoom;
	m_fLevelOffset += fLevelScroll / m_fLevelZoom;

	UpdateGraph();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::MouseZoom
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXɂY[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fTimePos1		[I] Y[Jnʒu
//		double		fTimePos2		[I] Y[Iʒu
//		double		fLevelPos1		[I] cY[Jnʒu
//		double		fLevelPos2		[I] cY[Iʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::MouseZoom(double fTimePos1, double fTimePos2, double fLevelPos1, double fLevelPos2)
{
	if (fTimePos1 > fTimePos2) {
		double fTimePos = fTimePos1;
		fTimePos1 = fTimePos2;
		fTimePos2 = fTimePos;
	}

	if (fLevelPos1 > fLevelPos2) {
		double fLevelPos = fLevelPos1;
		fLevelPos1 = fLevelPos2;
		fLevelPos2 = fLevelPos;
	}

	m_fTimeOffset += fTimePos1 / m_fTimeZoom;
	m_fTimeZoom /= fTimePos2 - fTimePos1;

	m_fLevelOffset += fLevelPos1 / m_fLevelZoom;
	m_fLevelZoom /= fLevelPos2 - fLevelPos1;

	m_wndGraphBar.SetTimeZoom(log(m_fTimeZoom) / 5);
	m_wndGraphBar.SetLevelZoom(log(m_fLevelZoom) / 5);

	UpdateGraph();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphFrm::ZoomReset
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Y[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphFrm::ZoomReset()
{
	m_fTimeZoom = 1;
	m_fLevelZoom = 1;

	m_wndGraphBar.SetTimeZoom(0);
	m_wndGraphBar.SetLevelZoom(0);

	UpdateGraph();
}
